/*******************************************************************************
 * ParTypes VCC library - Choice handling
 ******************************************************************************/
#ifndef __Choice_h__ /* { */
#define __Choice_h__
_(pure \bool     choiceEval(Protocol st))
_(pure Protocol choiceIfTrue(Protocol st))
_(pure Protocol choiceIfFalse(Protocol st))
_(
axiom \forall \bool b; Protocol p1, p2; choiceEval(choice(b,p1,p2)) == b;
axiom \forall \bool b; Protocol p1, p2; choiceIfTrue(choice(b,p1,p2)) == p1;
axiom \forall \bool b; Protocol p1, p2; choiceIfFalse(choice(b,p1,p2)) == p2;
)

// Note: due to nested scoping, variables need to be named differently each time.
// The ## pre-processor operator combined with the __LINE__ preprocessor macro does the trick.
#define _ifc(condition, ifTrueBody, ifFalseBody)                         \
{                                                                        \
  _(ghost Cons _pair_ ## __LINE__ = cons(_protocol, _rank))              \
  _(ghost Protocol _head_ ## __LINE__ = head(_pair_ ## __LINE__))        \
  _(assert (condition) == choiceEval(_head_ ## __LINE__))                \
  if (condition) {                                                       \
    _(ghost _protocol = choiceIfTrue(_head_ ## __LINE__))                \
    { ifTrueBody }                                                       \
  } else {                                                               \
    _(ghost _protocol = choiceIfFalse(_head_ ## __LINE__))               \
    { ifFalseBody }                                                      \
  }                                                                      \
  _(assert isSkip(_protocol, _rank))                                     \
  _(ghost _protocol = tail(_pair_ ## __LINE__))                          \
}

#define _case(e) if (e)

   
#endif /* } */
