/*******************************************************************************
 * ParTypes VCC library - Foreach handling
 ******************************************************************************/
#ifndef __Foreach_h__ /* { */
#define __Foreach_h__

_(pure \integer foreachUpper(Protocol st))
_(pure IntAbs   foreachBody(Protocol st))
_(
axiom \forall \integer n; IntAbs body;
  foreachUpper(foreach(n, body)) == n;
axiom \forall \integer n; IntAbs body;
  foreachBody(foreach(n, body)) == body;
)

// Note: due to nested scoping variables need to be named differently each time.
// The ## pre-processor operator does the trick.
#define _for(var,n,bodyOfLoop)                                           \
{                                                                        \
  _(ghost Cons _pair_ ## __LINE__ = cons(_protocol, _rank))              \
  _(ghost Protocol _head_ ## __LINE__ = head(_pair_ ## __LINE__))        \
  _(assert (n) == foreachUpper(_head_ ## __LINE__))                      \
  _(ghost IntAbs _body_ ## __LINE__ = foreachBody(_head_ ## __LINE__))   \
  for (var = 0; var < (n); var ++) _(writes {}) {                        \
    _(ghost _protocol = _body_ ## __LINE__ [var])                        \
    { bodyOfLoop }                                                       \
    _(assert isSkip(_protocol,_rank))                                    \
  }                                                                      \
  _(ghost _protocol = tail(_pair_ ## __LINE__))                          \
}

#define _case(e) if (e)

   
#endif /* } */
