/*******************************************************************************
 * ParTypes VCC library :: MPI_AllGather
 ******************************************************************************/

#ifndef __MPI_Allgather_h__ /* { */
#define __MPI_Allgather_h__

_(pure Data allgatherData(Protocol p))
_(
axiom \forall Data d;
  allgatherData(allgather(d)) == d;
)

#define MPI_Allgather(sendbuf,sendcount,sendtype,recvbuf,recvcount,recvtype,comm) {  \
  _(assert (sendtype == recvtype) && (sendcount) == (recvcount))                     \
  _(ghost Cons _pair = cons(_protocol, _rank))                                       \
  _(ghost Protocol _head = head(_pair))                                              \
  _(ghost Data _data = allgatherData(_head))                                         \
  _assertData(_data,sendtype,sendbuf,sendcount)                                      \
  _(ghost _protocol = tail(_pair))                                                   \
}


#endif /* } */
