/*******************************************************************************
 * ParTypes VCC library :: MPI_Allreduce
 ******************************************************************************/
#ifndef __MPI_Allreduce_h__ /* { */
#define __MPI_Allreduce_h__

_(pure MPI_Op allreduceOp(Protocol p))
_(pure Data allreduceData(Protocol p))
_(
axiom \forall MPI_Op op; Data d;
  allreduceOp(allreduce(op,d)) == op;
axiom \forall MPI_Op op; Data d;
  allreduceData(allreduce(op,d)) == d;
)

#define MPI_Allreduce(sendbuf, recvbuf, count, datatype, op, comm)     \
{                                                                      \
  _(ghost Cons _pair = cons(_protocol, _rank))                         \
  _(ghost Protocol _head = head(_pair))                                \
  _(assert allreduceOp(_head) == op )                                  \
  _(ghost Data _data = allreduceData(_head))                           \
  _assertData(_data,datatype,sendbuf,count)                            \
  _(ghost _protocol = tail(_pair))                                     \
}
;


#endif /* } */
