/*******************************************************************************
 * ParTypes VCC library :: MPI_Bcast
 ******************************************************************************/
#ifndef __MPI_Bcast_h__
#define __MPI_Bcast_h__ /* { */


_(pure \integer intBcastRoot(Protocol p))
_(pure IntPred intBcastPred(Protocol p))
_(pure IntAbs intBcastAbs(Protocol p))
_(pure \integer intArrayBcastRoot(Protocol p))
_(pure IntArrayPred intArrayBcastPred(Protocol p))
_(pure IntArrayAbs intArrayBcastAbs(Protocol p))
_(pure \integer floatArrayBcastRoot(Protocol p))
_(pure FloatArrayPred floatArrayBcastPred(Protocol p))
_(pure FloatArrayAbs floatArrayBcastAbs(Protocol p))
_(
axiom \forall \integer root; IntPred p; IntAbs a;
  intBcastRoot(intBcast(root,p,a)) == root;
axiom \forall \integer root; IntPred p; IntAbs a;
  intBcastPred(intBcast(root,p,a)) == p;
axiom \forall \integer root; IntPred p; IntAbs a;
  intBcastAbs(intBcast(root,p,a)) == a;

axiom \forall \integer root; IntArrayPred p; IntArrayAbs a;
  intArrayBcastRoot(intArrayBcast(root,p,a)) == root;
axiom \forall \integer root; IntArrayPred p; IntArrayAbs a;
  intArrayBcastPred(intArrayBcast(root,p,a)) == p;
axiom \forall \integer root; IntArrayPred p; IntArrayAbs a;
  intArrayBcastAbs(intArrayBcast(root,p,a)) == a;

axiom \forall \integer root; FloatArrayPred p; FloatArrayAbs a;
  floatArrayBcastRoot(floatArrayBcast(root,p,a)) == root;
axiom \forall \integer root; FloatArrayPred p; FloatArrayAbs a;
  floatArrayBcastPred(floatArrayBcast(root,p,a)) == p;
axiom \forall \integer root; FloatArrayPred p; FloatArrayAbs a;
  floatArrayBcastAbs(floatArrayBcast(root,p,a)) == a;
)

#define MPI_Bcast(array, length, datatype, root, comm) {              \
  _(ghost Cons _pair = cons(_protocol, _rank))                        \
  _(ghost Protocol _head = head(_pair))                               \
  _(ghost Protocol _tail = tail(_pair))                               \
  _(ghost Protocol _cont;)                                            \
  _(assert datatype == MPI_INT || datatype == MPI_FLOAT)              \
  if (datatype == MPI_INT && length == 1) {                           \
    _(assert (root) == intBcastRoot(_head))                           \
    _(ghost IntPred _pred = intBcastPred(_head))                      \
    _(ghost IntAbs _abs = intBcastAbs(_head))                         \
    _(assert _rank == root ==> _pred[*((int*)array)])                 \
    _(assume _rank != root ==> _pred[*((int*)array)])                 \
    _(ghost _cont = _abs[*((int*)array)])                             \
   } else if (datatype == MPI_INT) {                                  \
    _(assert (root) == intArrayBcastRoot(_head))                      \
    _(ghost IntArrayPred _pred = intArrayBcastPred(_head))            \
    _(ghost IntArrayAbs _abs = intArrayBcastAbs(_head))               \
    _(assert _rank == root ==> _pred[(int*)array][length])            \
    _(assume _rank != root ==> _pred[(int*)array][length])            \
    _(ghost _cont = _abs[(int*)array][length])                        \
  } else {                                                            \
    _(assert (root) == floatArrayBcastRoot(_head))                    \
    _(ghost FloatArrayPred _pred = floatArrayBcastPred(_head))        \
    _(ghost FloatArrayAbs _abs = floatArrayBcastAbs(_head))           \
    _(assert _rank == root ==> _pred[(float*)array][length])          \
    _(assume _rank != root ==> _pred[(float*)array][length])          \
    _(ghost _cont = _abs[(float*)array][length])                      \
  }                                                                   \
  _(ghost _protocol = seq(_cont,_tail))                               \
}




#endif /* } */
