/*******************************************************************************
 * ParTypes VCC library :: MPI_Gather
 ******************************************************************************/
#ifndef __MPI_Gather_h__ /* { */
#define __MPI_Gather_h__

_(pure \integer gatherRoot(Protocol p))
_(pure Data gatherData(Protocol p))
_(
axiom \forall \integer root; Data d;
  gatherRoot(gather(root,d)) == root;
axiom \forall \integer root; Data d;
  gatherData(gather(root,d)) == d;
)

#define MPI_Gather(sendbuf,sendcount,sendtype,recvbuf,recvcount,recvtype,root,comm) {   \
  _(assert (sendtype == recvtype) && (sendcount) == (recvcount))                        \
  _(ghost Cons _pair = cons(_protocol, _rank))                                          \
  _(ghost Protocol _head = head(_pair))                                                 \
  _(assert gatherRoot(_head) == root)                                                   \
  _(ghost Data _data = gatherData(_head))                                               \
  _assertData(_data,sendtype,sendbuf,sendcount)                                         \
  _(ghost _protocol = tail(_pair))                                                      \
}


#endif /* } */
