/*******************************************************************************
 * ParTypes VCC library :: MPI_Init() and MPI_Finalize
 ******************************************************************************/

#ifndef __MPI_InitAndFinalize_h__ /* { */
#define __MPI_InitAndFinalize_h__

_(pure IntPred sizePred(Protocol p))
_(pure IntAbs  sizeAbs(Protocol p))
_(
axiom \forall IntPred pred; IntAbs abs; sizePred(size(pred,abs)) == pred;
axiom \forall IntPred pred; IntAbs abs; sizeAbs(size(pred,abs)) == abs;
)


#define MPI_Init(argc,argv) \
  _(ghost Protocol _protocol = program_protocol();)             \
  _(ghost int _rank;)                                           \
  _(ghost int _size;)                                           \
  _(assume _size >= 1 && 0 <= _rank && _rank < _size)           \
{                                                               \
  _(ghost Cons _pair = cons(_protocol, _rank))                  \
  _(ghost Protocol _head = head(_pair))                         \
  _(ghost IntPred _pred = sizePred(_head))                      \
  _(ghost IntAbs  _abs  = sizeAbs(_head))                       \
  _(assume _pred[_size])                                        \
  _(ghost _protocol = seq(_abs[_size],tail(_pair)))             \
} 
 
#define MPI_Finalize() \
  _(assert isSkip(_protocol, _rank)) \

// ADD THIS ALSO FOR SANITY CHECKS  _(assert \false)

#endif /* } */
