/*******************************************************************************
 * ParTypes VCC library :: MPI_Reduce
 ******************************************************************************/
#ifndef __MPI_Reduce_h__ /* { */
#define __MPI_Reduce_h__


_(pure \integer reduceRoot(Protocol p))
_(pure MPI_Op reduceOp(Protocol p))
_(pure Data reduceData(Protocol p))
_(
axiom \forall \integer root; MPI_Op op; Data d;
  reduceRoot(reduce(root,op,d)) == root;
axiom \forall \integer root; MPI_Op op; Data d;
  reduceOp(reduce(root,op,d)) == op;
axiom \forall \integer root; MPI_Op op; Data d;
  reduceData(reduce(root,op,d)) == d;
)



#define MPI_Reduce(sendbuf, recvbuf, count, datatype, op, root, comm)  \
{                                                                      \
  _(ghost Cons _pair = cons(_protocol, _rank))                         \
  _(ghost Protocol _head = head(_pair))                                \
  _(assert reduceRoot(_head) == root )                                 \
  _(assert reduceOp(_head)   == op )                                   \
  _(ghost Data _data = reduceData(_head))                              \
  _assertData(_data,datatype,sendbuf,count)                            \
  _(ghost _protocol = tail(_pair))                                     \
}



#endif /* } */
