/*******************************************************************************
 * ParTypes VCC library :: MPI_Scatter
 ******************************************************************************/
#ifndef __MPI_Scatter_h__ /* { */
#define __MPI_Scatter_h__

_(pure \integer scatterRoot(Protocol p))
_(pure Data scatterData(Protocol p))
_(
axiom \forall \integer root; Data d;
  scatterRoot(scatter(root,d)) == root;
axiom \forall \integer root; Data d;
  scatterData(scatter(root,d)) == d;
)
#define MPI_Scatter(sendbuf,sendcount,sendtype,recvbuf,recvcount,recvtype,root,comm) {  \
  _(assert (sendtype == recvtype) && (sendcount) == (recvcount))                        \
  _(ghost Cons _pair = cons(_protocol, _rank))                                          \
  _(ghost Protocol _head = head(_pair))                                                 \
  _(assert scatterRoot(_head) == root)                                                  \
  _(ghost Data _data = scatterData(_head))                                              \
  int _rankNonGhost;                                                                    \
  _(assume _rankNonGhost == _rank)                                                      \
  if (_rankNonGhost == (root)) {                                                        \
    _assertData(_data,sendtype,sendbuf,_size * (sendcount))                             \
  }                                                                                     \
  _(ghost _protocol = tail(_pair))                                                      \
}


#endif /* } */
