/*******************************************************************************
 * ParTypes VCC library :: MPI_Send
 ******************************************************************************/

#ifndef __MPI_SendAndRecv_h__ /* { */
#define __MPI_SendAndRecv_h__

_(pure \integer messageFrom(Protocol p))
_(pure \integer messageTo(Protocol p))
_(pure Data messageData(Protocol p))
_(
axiom \forall \integer from,to; Data data;
   messageFrom(message(from,to,data)) == from;
axiom \forall \integer from,to; Data data;
   messageTo(message(from,to,data)) == to;
axiom \forall \integer from,to; Data data;
   messageData(message(from,to,data)) == data;
)

#define MPI_Send(buf, count, datatype, to, tag, comm)            \
{                                                                \
  _(assert tag == 0)                                             \
  _(ghost Cons _pair = cons(_protocol, _rank))                   \
  _(ghost Protocol _head = head(_pair))                          \
  _(assert messageFrom(_head) == _rank )                         \
  _(assert messageTo(_head)   == to    )                         \
  _(ghost Data _data = messageData(_head);)                      \
  _assertData(_data,datatype,buf,count)                          \
  _(ghost _protocol  = tail(_pair);)                             \
}

#define MPI_Recv(buf, count, datatype, from, tag, comm, status)  \
{                                                                \
  _(assert tag == 0)                                             \
  _(ghost Cons _pair = cons(_protocol, _rank))                   \
  _(ghost Protocol _head = head(_pair))                          \
  _(assert messageFrom(_head) == from )                          \
  _(assert messageTo(_head)   == _rank )                         \
  _(ghost Data _data = messageData(_head))                       \
  _assumeData(_data,datatype,buf,count)                          \
  _(ghost _protocol  = tail(_pair))                              \
}
;

#endif /* } */
