/*******************************************************************************
 * ParTypes VCC library - utility definitions shared by several primitives.
 *******************************************************************************/
#ifndef _SharedLogic_h_
#define _SharedLogic_h_

// TODO: rename to conformsIntArray
_(pure \bool verifyDataI(Data d, int* buf, \integer length))
_(
axiom \forall IntArrayPred pred; int* buf; \integer length;
   pred[buf][length] <==> verifyDataI(intArrayRefin(pred),buf,length)
)

// TODO: rename to conformsFloatArray
_(pure \bool verifyDataF(Data d, float* buf, \integer length))
_(
axiom \forall FloatArrayPred p; float* buf; \integer length;
   p[buf][length] <==> verifyDataF(floatArrayRefin(p),buf, length)
)

_(pure Data anyInt() 
 _(ensures \result == intRefin(\lambda \integer v; \true))
)

_(pure Data intArrayOfLength(\integer len)
  _(ensures \result ==
intArrayRefin(\lambda int* v; \lambda \integer n; n == len))
)

_(pure Data floatArrayOfLength(\integer len)
  _(ensures \result ==
floatArrayRefin(\lambda float* v; \lambda \integer n; n == len))
)

#define _assertData(data, datatype, buf, count)  \
{ \
  _(assert datatype == MPI_INT || datatype == MPI_FLOAT) \
  if (datatype == MPI_INT) \
    _(assert verifyDataI(data,(int*)(buf),count)) \
  else \
    _(assert verifyDataF(data,(float*) buf, count)) \
}
#define _assumeData(data, datatype, buf, count)  \
{ \
  _(assert datatype == MPI_INT || datatype == MPI_FLOAT) \
  if (datatype == MPI_INT) \
    _(assume verifyDataI(data,(int*)(buf),count)) \
  else \
    _(assume verifyDataF(data,(float*) buf, count)) \
}

_(pure IntArrayPred intArrayWithProp(\integer len, IntPred pred)
  _(reads \universe())
  _(ensures \result ==
    \lambda int* v; \lambda \integer n; n == len && (\forall \integer i; i >= 0 && i < len ==> pred[v[i]])
   )
;
)

#endif


