/*******************************************************************************
 * ParTypes VCC library :: handling of val()
 ******************************************************************************/
#ifndef __Val_h__
#define __Val_h__ /* { */


_(pure IntPred intValPred(Protocol p))
_(pure IntAbs intValAbs(Protocol p))
_(pure IntArrayPred intArrayValPred(Protocol p))
_(pure IntArrayAbs intArrayValAbs(Protocol p))
_(pure FloatArrayPred floatArrayValPred(Protocol p))
_(pure FloatArrayAbs floatArrayValAbs(Protocol p))
_(
axiom \forall IntPred p; IntAbs a; 
 intValPred(intVal(p,a)) == p; 
axiom \forall IntPred p; IntAbs a; 
 intValAbs(intVal(p,a)) == a; 

axiom \forall IntArrayPred p; IntArrayAbs a; 
 intArrayValPred(intArrayVal(p,a)) == p; 
axiom \forall IntArrayPred p; IntArrayAbs a; 
 intArrayValAbs(intArrayVal(p,a)) == a; 

axiom \forall FloatArrayPred p; FloatArrayAbs a; 
 floatArrayValPred(floatArrayVal(p,a)) == p; 
axiom \forall FloatArrayPred p; FloatArrayAbs a; 
 floatArrayValAbs(floatArrayVal(p,a)) == a; 
)

#define _applyInt(value) {                                      \
  _(ghost Cons _pair = cons(_protocol, _rank))                  \
  _(ghost Protocol _head = head(_pair))                         \
  _(ghost IntPred _pred = intValPred(_head))                    \
  _(ghost IntAbs _abs = intValAbs(_head))                       \
  _(assert _pred[value])                                        \
  _(ghost _protocol  = seq(_abs[value],tail(_pair)))            \
}

#define _applyIntArray(array,length) {                          \
  _(ghost Cons _pair = cons(_protocol, _rank))                  \
  _(ghost Protocol _head = head(_pair))                         \
  _(ghost IntArrayPred _pred = intArrayValPred(_head))          \
  _(ghost IntArrayAbs _abs = intArrayValAbs(_head))             \
  _(assert _pred[array][length])                                \
  _(ghost _protocol  = seq(_abs[array][length],tail(_pair)))    \
}

#define _applyFloatArray(array,length) {                        \
  _(ghost Cons _pair = cons(_protocol, _rank))                  \
  _(ghost Protocol _head = head(_pair))                         \
  _(ghost FloatArrayPred _pred = floatArrayValPred(_head))      \
  _(ghost FloatArrayAbs _abs = floatArrayValAbs(_head))         \
  _(assert _pred[array][length])                                \
  _(ghost _protocol  = seq(_abs[array][length],tail(_pair)))    \
}


#endif /* } */
