/*******************************************************************************
 * ParTypes VCC library :: main header file.
 *
 * For verification this file should be reachable in VCC's preprocessor path. 
 * Note that annotated C+MPI files do not need to include vcc.h .
 ******************************************************************************/

#ifndef __mpi_h__ /* { */
#define __mpi_h__

#define _PARTYPES

// The VCC header
#include <vcc.h>

// Base logic
#include "MPI_types.h"
#include "Protocol.h"
#include "SharedLogic.h"
#include "Val.h"
#include "Choice.h"
#include "Foreach.h"

// MPI primitives
#include "MPI_CommRankAndSize.h"
#include "MPI_InitAndFinalize.h"
#include "MPI_SendAndRecv.h"
#include "MPI_Bcast.h"
#include "MPI_Reduce.h"
#include "MPI_AllReduce.h"
#include "MPI_Scatter.h"
#include "MPI_Gather.h"
#include "MPI_AllGather.h"

// Contract for main function (required for memory-related annotations by vcc)
#include "ContractForMain.h"

#endif /* } */

